#define _AWACS_PCM_C_
/*
 * sound/awacs_pcm.c
 *
 * The low level driver for the Audio Waveform Amplifier & Converters (AWACs) Chip.
 */
	 
#include <linux/config.h>
#include "sound_config.h"

#if defined(CONFIG_AWACS)

#include <asm/dbdma.h>
#include <linux/delay.h>

#include "awacs.h"

#undef DEB
#define DEB(what)	/* (what) */
#undef DEB2
#define DEB2(what)	(what)

#include "awacs_kbeep.c"

int awacs_beep(void)
{
	struct dbdma_cmd	*dcmd, *dp;
	static struct dbdma_cmd	dcmd_space[KBEEP_BUFSIZE / MAX_DMACOUNT + 3];
	int					len;
	char 				*buf;

	DEB(printk("awacs_pcm.c: awacs_beep()\n"));
	
	if (awacs_busy)
		return -1;
	
	awacs_set_speed(KBEEP_SPEED);
	awacs_set_bits(AFMT_S16_LE);
	
	dcmd = (struct dbdma_cmd *) DBDMA_ALIGN(dcmd_space);
	memset(dcmd, 0, 2 * sizeof(struct dbdma_cmd));
	
	st_le32(AUD_OUT_CHCONT, (RUN) << 16);	/* stop the channel */
	eieio();
	st_le32(AUD_OUT_INTRSEL, 0);
	st_le32(AUD_OUT_BRSEL, 0);
	st_le32(AUD_OUT_WAITSEL, 0);

	buf = (char *) kbeep_buf;
	len = KBEEP_BUFSIZE;
	for (dp = dcmd; len > MAX_DMACOUNT; ++dp) {
		init_dma(dp, OUTPUT_MORE, buf, MAX_DMACOUNT);
		buf += MAX_DMACOUNT;
		len -= MAX_DMACOUNT;
	}
	init_dma(dp, OUTPUT_LAST, buf, len);
	init_dma(dp + 1, DBDMA_STOP, 0, 0);
	st_le32(AUD_OUT_CMDPTR, virt_to_phys(dcmd));
	eieio();
	st_le32(AUD_OUT_CHCONT, ((RUN) << 16) | (RUN));
	eieio();

	return 0;
}


#endif /* defined(CONFIG_AWACS) */

