#ifndef _LINUX_TIVO_DISKMON_H
#define _LINUX_TIVO_DISKMON_H

enum diskmon {
   DISKMON_IDLE = 0,
   DISKMON_LEGACY = 1,
   DISKMON_MFS = 2,
   DISKMON_MEDIA = 3,
   DISKMON_MEDIA_DEADLINE = 4,
   DISKMON_MAX_CLASSES = 10
};

struct diskactivity {
   long int usage [DISKMON_MAX_CLASSES];
};

#define DISKUSAGE_VERSION 1

struct diskusage {
   int version;
   struct diskactivity shortterm;
   struct diskactivity mediumterm;
   struct diskactivity longterm;
};

enum diskconditions {
   DISKCONDITION_READ_MISSED_DEADLINE = 0x00000001,
   DISKCONDITION_WRITE_MISSED_DEADLINE = 0x00000002,
   DISKCONDITION_READ_ERROR = 0x00000004,
   DISKCONDITION_WRITE_ERROR = 0x00000008
};

#define DISKWATCHER_VERSION 1

struct diskwatcher {
   int version;
   unsigned long int conditions;
   struct diskactivity thresholds;
};

#endif

